function controlSocketConnect(manual, noAccountChange) {
  if (manual) {                                                      // this is not a reconnection attempt
    isReconnecting = false;
    reconnectAttempts = parseInt(attempts);
    if (!reconnectAttempts || reconnectAttempts < 1)
      reconnectAttempts = 1;

    statusBarClear = false;
    if (!noAccountChange)
      onAccountChange();
  }
  
  host = host.replace(/^ftp:\/*/, '');                               // error checking - get rid of 'ftp://'
  if (host && host.charAt(host.length - 1) == '/')
    host = host.substring(0, host.length - 1);

  if (host == "about:mozilla") {                                     // just for fun
    window.openDialog("chrome://fireftp/content/welcome.xul","welcome",
      "width=400,height=200,chrome,modal=no,dialog=yes,resizable=yes,centerscreen", welcomeMessage, true);
    gConnectButton.label = "Flame On!";
    gConnectButton.setAttribute('accesskey', "F");
    return;
  }

  if (!host) {                                                       // need to fill in the host
    window.openDialog("chrome://fireftp/content/alert.xul","alert",
      "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", strbundle.getString("alertFillHost"));
    return;
  }
  if (!port || !parseInt(port)) {                                    // need a valid port
    window.openDialog("chrome://fireftp/content/alert.xul","alert",
      "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", strbundle.getString("alertFillPort"));
    return;
  }
  if (!password && !passwordMode) {                                  // get a password if needed
    var passwordObject = new Object();
    passwordObject.password = "";
    passwordObject.returnVal = false;
    window.openDialog("chrome://fireftp/content/password.xul","password",
      "width=275,height=125,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", passwordObject);
    if (passwordObject.returnVal)
      password = passwordObject.password;
    else
      return;
  }

  gConnectButton.label = strbundle.getString("disconnectButton");
  gConnectButton.setAttribute('command','cmd_disconnect');
  gConnectButton.setAttribute('accesskey', strbundle.getString("disconnectAccess"));

  if (!eventQueue.length || eventQueue[0].cmd != "welcome")          // wait for welcome message first
    unshiftEventQueue("welcome", "", "");

  try {                                                              // create a control socket
    var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"]
                                     .getService(Components.interfaces.nsISocketTransportService);

    var proxyInfo = null;

    if (proxyType != "") {                                           // use a proxy
      var proxyService = Components.classes["@mozilla.org/network/protocol-proxy-service;1"]
                                   .getService(Components.interfaces.nsIProtocolProxyService);
      proxyInfo = proxyService.newProxyInfo(proxyType, proxyHost, proxyPort, 0, 30, null);
    }

    if (security == "ssl")                                           // thanks to Scott Bentley. he's a good man, Jeffrey. and thorough.
      controlTransport = transportService.createTransport(["ssl"], 1, host, parseInt(port), proxyInfo);
    else if (!security)
      controlTransport = transportService.createTransport(null, 0, host, parseInt(port), proxyInfo);
    else
      controlTransport = transportService.createTransport(["starttls"], 1, host, parseInt(port), proxyInfo);

    controlOutstream  = controlTransport.openOutputStream(0, 0, 0);
    var controlStream = controlTransport.openInputStream(0, 0, 0);
    controlInstream   = Components.classes["@mozilla.org/scriptableinputstream;1"]
                                  .createInstance(Components.interfaces.nsIScriptableInputStream);
    controlInstream.init(controlStream);

    var dataListener = {                                             // async data listener for the control socket
      data : "",
      onStartRequest: function(request, context) {},
      onStopRequest: function(request, context, status) {
        if (!isConnected)                                            // no route to host
          appendLog(strbundle.getString("errorConn"), 'color:red;font-weight:bold;', "error");
        isConnected = false;
        connectedButtonsDisabler();

        killDataSocket();

        gConnectButton.label = strbundle.getString("connectButton");
        gConnectButton.setAttribute('command','cmd_connect');
        gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));

        if (!legitClose && timeoutMode) {                            // try reconnecting
          isReconnecting = true;
          document.getElementById('abortbutton').disabled = false;
          setTimeout("tryReconnect()", retry * 1000);
        } else
          eventQueue = new Array;
      },
      onDataAvailable: function(request, context, inputStream, offset, count) {
        this.data = controlInstream.read(count);                     // read data
        readControl(this.data);
      }
    };

    var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"]
                         .createInstance(Components.interfaces.nsIInputStreamPump);
    pump.init(controlStream, -1, -1, 0, 0, false);
    pump.asyncRead(dataListener,null);

  } catch(ex) {
    error(strbundle.getString("errorConn"));
    debug(ex,12);
    connectedButtonsDisabler();

    gConnectButton.label = strbundle.getString("connectButton");
    gConnectButton.setAttribute('command','cmd_connect');
    gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));

    eventQueue = new Array;
    return;
  }
}
function tryReconnect()  { // ahhhh! our precious connection has been lost, must...get it...back...our...precious
  if (!isReconnecting)
    return;

  --reconnectAttempts;
  if (reconnectAttempts < 0)
    return;
  
  controlSocketConnect();
}
function disconnect() {
  // haven't connected yet, changed our minds and decided to invade canada instead (just playin' canada...naw, i'm serious)
  if (!isConnected && eventQueue.length && eventQueue[0].cmd == "welcome") {
    gConnectButton.label = strbundle.getString("connectButton");
    gConnectButton.setAttribute('command','cmd_connect');
    gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));
    eventQueue = new Array;

    try {                                                            // try closing everything
      controlInstream.close();
    } catch(ex) { debug(ex,1); }
    try {
      controlOutstream.close();
    } catch(ex) { debug(ex,2); }
  } else if (isConnected) {
    if (eventQueue.length)
      if (!confirm(strbundle.getString("reallyclose")))
        return;
    legitClose        = true;                                        // this close() is ok, don't try to reconnect
    eventQueue        = new Array;
    trashQueue        = new Array;
    pauseTrashQueue   = new Array;
    pauseEventQueue   = new Array;
    suppressQueue     = false;
    gRemotePath.value = '/';
    remotePathFocus   = '/';
    document.title    = "FireFTP";
    close();
  }
}
function addEventQueue(cmd, parameter, remember) {                   // this just creates a new queue item
  parameter = parameter ? parameter : '';
  remember  = remember ? remember : '';
  eventQueue.push( { cmd: cmd, parameter: parameter, remember: remember } );
}
function unshiftEventQueue(cmd, parameter, remember) {               // ditto
  parameter = parameter ? parameter : '';
  remember  = remember ? remember : '';
  eventQueue.unshift( { cmd: cmd, parameter: parameter, remember: remember } );
}
function writeControl(cmd, parameter) {
  try {
    if (cmd == "aborted" || cmd == "goodbye") {                      // these are sort of dummy values
      eventQueue.shift();
      if (eventQueue.length) {
        cmd = eventQueue[0].cmd;
        parameter = eventQueue[0].parameter;
      } else
        return;
    }

    isReady = false;
    if (!pasvMode && cmd == "PASV") {                                // active mode
      cmd = "PORT";
      activeConnected = false;
      try {
        var DNSService = Components.classes["@mozilla.org/network/dns-service;1"]
                                   .getService(Components.interfaces.nsIDNSService);
        var ipAddress = DNSService.resolve(DNSService.myHostName, false).getNextAddrAsString();
        var re = /\x2e/g;
        var serverSocket = Components.classes["@mozilla.org/network/server-socket;1"]
                                     .createInstance(Components.interfaces.nsIServerSocket);
        var serverListener = {
          onSocketAccepted: function(serv, transport) {
            dataTransport = transport;
            if (activeCmd == "LIST")
              dataSocketConnect(false, '', 0, 0, transport);
            else if (activeCmd == "RETR")
              dataSocketConnect(false, activeRemember, activeRemember2, 0, transport);
            else if (activeCmd == "REST")
              dataSocketConnect(false, activeRemember, activeRemember2, activeRemember3, transport);
            else if (activeCmd == "STOR")
              dataSocketConnect(true, activeRemember, 0, 0, transport);
            else if (activeCmd == "APPE")
              dataSocketConnect(true, activeRemember, 0, activeRemember2, transport);
          },
          onStopListening: function(serv, status) {}
        };
        serverSocket.init(-1, false, -1);
        serverSocket.asyncListen(serverListener);
        parameter = ipAddress.replace(re, ",") + "," + parseInt(serverSocket.port / 256) + "," + serverSocket.port % 256;
      } catch (ex) { 
        error(strbundle.getString("errorDataConn"));
        debug(ex,13);
        return;
      }
    }
    if (cmd == "LIST")                                               // don't include path in list command - breaks too many things
      parameter = hiddenMode ? "-al" : "";
    var outputData = cmd + (parameter ? (' ' + parameter) : '') + "\r\n";  // thanks to devin
    controlOutstream.write(outputData,outputData.length);            // write!

    ++networkTimeoutID;                                              // this checks for timeout
    setTimeout("checkTimeout(" + networkTimeoutID + ",'" + cmd + "')", network * 1000);
    
    outputData = cmd + (parameter ? (' ' + parameter) : '');         // write it out to the log
    if (cmd != "PASS")
      appendLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" + outputData, 'color:blue', "info");
    else
      appendLog("&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;PASS " + strbundle.getString("passNotShown"), 'color:blue', "info");
  } catch(ex) {
    error(strbundle.getString("errorConn"));
    debug(ex,14);
  }
}
function readControl(buffer) {
  if ((buffer == "2" && !isConnected) || buffer == "\r\n")
    return;
  var lastLineOfBuffer = buffer.split("\r\n");

  if (buffer != "2") {                                               // "2"s are self-generated fake messages
    for (var x = 0; x < lastLineOfBuffer.length; ++x) {              // add response to log
      var message = lastLineOfBuffer[x].charAt(lastLineOfBuffer[x].length - 1) == '\r'
          ? lastLineOfBuffer[x].substring(0, lastLineOfBuffer[x].length - 1) : lastLineOfBuffer[x];
      var errorBlah = lastLineOfBuffer[x].charAt(0) == '4' || lastLineOfBuffer[x].charAt(0) == '5';  // naming the var 'error' actually overwrote
      appendLog(message, errorBlah ? 'color:red;font-weight:bold' : 'color:green', errorBlah ? "error" : "info");    // the function, go figure
    }
  }
  
  lastLineOfBuffer = lastLineOfBuffer[lastLineOfBuffer.length - 1];  // we are only interested in what the last line says
  var returnCode;

                                                                     // see if the message is finished or not
  if ((lastLineOfBuffer.length > 3 && lastLineOfBuffer.charAt(3) == '-') || lastLineOfBuffer.charAt(0) == ' ') {
    if (eventQueue[0].cmd == "USER" || eventQueue[0].cmd == "PASS")
      welcomeMessage += buffer;
    return;
  } else
    returnCode = parseInt(lastLineOfBuffer.charAt(0));               // looks at first number of number code

  var cmd;  var parameter;    var remember;

  if (eventQueue.length) {
    cmd = eventQueue[0].cmd;
    parameter = eventQueue[0].parameter;
    remember = eventQueue[0].remember;
    if (cmd != "LIST" && cmd != "RETR" && cmd != "STOR" && cmd != "APPE" &&
      cmd != "LIST2" && cmd != "RETR2" && cmd != "STOR2" && cmd != "APPE2") {  // used if we have a loss in connection
      var throwAway = eventQueue.shift();
      if (throwAway.cmd != "USER" && throwAway.cmd != "PASS" && throwAway.cmd != "PWD" &&
          throwAway.cmd != "welcome" && throwAway.cmd != "goodbye" && throwAway.cmd != "aborted" && throwAway.cmd != "NOOP" &&
          throwAway.cmd != "REST" && throwAway.cmd != "SIZE" && throwAway.cmd != "PBSZ" && throwAway.cmd != "AUTH")
        trashQueue.push(throwAway);
    }
  } else
    cmd = "default";                                                 // an unexpected reply - perhaps a 421 timeout message

  switch (cmd) {
    case "welcome":
      welcomeMessage = buffer;
      
      if (returnCode != 2) {
        displayWelcomeMessage();                                     // not so welcome, failed before login
        gConnectButton.label = strbundle.getString("connectButton");
        gConnectButton.setAttribute('command','cmd_connect');
        gConnectButton.setAttribute('accesskey', strbundle.getString("connectAccess"));
        break;
      }
      
      isConnected = true;                                            // good to go
      connectedButtonsDisabler();
      isReconnecting = false;
      reconnectAttempts = parseInt(attempts);                        // setup reconnection settings
      if (!reconnectAttempts || reconnectAttempts < 1)
        reconnectAttempts = 1;

      initialPath = gRemotePath.value;                               // save the path (and the seamonkeys)

      unshiftEventQueue("USER", login, "");
     
      if (security)
        unshiftEventQueue("PBSZ", "0", "");
      if (security == "authtls")
        unshiftEventQueue("AUTH", "TLS", "");
      else if (security == "authssl")
        unshiftEventQueue("AUTH", "SSL", "");
      break;
    case "AUTH":
      if (returnCode != 2) {
        error(buffer, true);
        isConnected = false;

        try {                                                        // try closing everything
          controlInstream.close();
        } catch(ex) { debug(ex,1); }
        try {
          controlOutstream.close();
        } catch(ex) { debug(ex,2); }
        return;
      } else {
        var si = controlTransport.securityInfo;
        si.QueryInterface(Components.interfaces.nsISSLSocketControl);
        si.StartTLS();
      }
      break;
    case "PBSZ":
      if (returnCode != 2) {
        error(buffer, true);
        isConnected = false;

        try {                                                        // try closing everything
          controlInstream.close();
        } catch(ex) { debug(ex,1); }
        try {
          controlOutstream.close();
        } catch(ex) { debug(ex,2); }
        return;
      }
    case "PROT":
      if (buffer.substring(0,3) == "534" && parameter == "P") {
        unshiftEventQueue("PROT", "C", "");
        break;
      }
      if (returnCode != 2) {                                         // TODO? fail more dramatically?
        error(buffer, true);
        protPSuccess = false;
      } else
        protPSuccess = parameter == "P";
      break;
    case "USER":
    case "PASS":
      if (returnCode == 2) {
        welcomeMessage += buffer;
        if (legitClose)
          displayWelcomeMessage();                                   // hello world only if it's not a reconnection attempt
        saveSession();

        if (!legitClose) {
          recoverFromDisaster();                                     // recover from previous disaster
          break;
        }
        legitClose = false;
        remotePathFocus = initialPath;
        gRemotePath.value = initialPath;                             // navigate to a directory

        unshiftEventQueue("PWD", "", "");
      } else if (cmd == "USER" && returnCode == 3) {
        unshiftEventQueue("PASS", password, "");
      } else {
        eventQueue = new Array;                                      // login failed, cleanup variables
        error(buffer, true);
        isConnected = false;

        try {                                                        // try closing everything
          controlInstream.close();
        } catch(ex) { debug(ex,1); }
        try {
          controlOutstream.close();
        } catch(ex) { debug(ex,2); }
        return;
      }
      break;
    case "PASV":
      if (returnCode != 2) {
        error(buffer, true);
        break;
      }

      emptyFileSoCloseLater = false;                                 // files that are empty are special cases
      if (pasvMode) {
        buffer = buffer.substring(buffer.indexOf("(") + 1, buffer.indexOf(")"));

        var re = /,/g;
        buffer = buffer.replace(re,".");                             // parsing the port to transfer to
        dataPort = parseInt(buffer.substring(buffer.lastIndexOf(".") + 1));
        dataPort += 256 * parseInt(buffer.substring(buffer.lastIndexOf(".", buffer.lastIndexOf(".") - 1) + 1, buffer.lastIndexOf(".") + 1));
        dataHost = buffer.substring(0, buffer.lastIndexOf(".", buffer.lastIndexOf(".") - 1));

        if (eventQueue[0].cmd == "LIST")                             // do what's appropriate
          dataSocketConnect();
        else if (eventQueue[0].cmd == "RETR")
          dataSocketConnect(false, eventQueue[0].remember, remember);
        else if (eventQueue[0].cmd == "REST")
          dataSocketConnect(false, eventQueue[1].remember, remember, eventQueue[0].parameter);
        else if (eventQueue[0].cmd == "STOR")
          dataSocketConnect(true, eventQueue[0].remember, 0, 0);
        else if (eventQueue[0].cmd == "APPE")
          dataSocketConnect(true, eventQueue[0].remember[0], 0, eventQueue[0].remember[1]);
      } else {
        activeCmd = eventQueue[0].cmd;                               // passive mode turned off
        if (eventQueue[0].cmd == "LIST")
          remember = remember ? remember : false;
        else if (eventQueue[0].cmd == "RETR") {
          activeRemember = eventQueue[0].remember;
          activeRemember2 = remember;
        } else if (eventQueue[0].cmd == "REST") {
          activeRemember = eventQueue[1].remember;
          activeRemember2 = remember;
          activeRemember3 = eventQueue[0].parameter;
        } else if (eventQueue[0].cmd == "STOR")
          activeRemember = eventQueue[0].remember;
        else if (eventQueue[0].cmd == "APPE") {
          activeRemember = eventQueue[0].remember[0];
          activeRemember2 = eventQueue[0].remember[1];
        }
      }
      break;
    case "APPE":
    case "LIST":
    case "RETR":
    case "STOR":
      if (cmd == "STOR" && emptyFileSoCloseLater) {                  // empty files are special cases
        try {
          dataTransport.close("Finished");
        } catch (ex) { debug(ex,42); }
      }
      eventQueue[0].cmd = cmd + "2";
      if (returnCode == 2) {
        if (dataFinished && !uploadStreamNeedsToBeClosed) {
          eventQueue.shift();
          trashQueue = new Array;                                    // clear the trash array, we've successfully completed an 'atomic' set of operations
          if (cmd == "LIST") {
            data = parseListData(data, hiddenMode ? parameter.substring(4, parameter.length) : parameter);
            eval(remember);                                          // send off list data to whoever wanted it
          }
          break;
        } else {
          setTimeout("readControl(\"2\")", 500);                     // give data stream some time to finish up
          return;
        }
      }
      if (returnCode != 1) {
        error(buffer, true);
        eventQueue.shift();
        trashQueue = new Array;
        killDataSocket();
        break;
      }
      return;
    case "APPE2":
    case "RETR2":
    case "STOR2":
    case "LIST2":
      if (returnCode != 2) {
        if (cmd != "RETR2" && buffer.substring(0,3) != "450")        // "450" errors are ok (i don't remember why though... :(
          error(buffer, true);
        eventQueue.shift();
        trashQueue = new Array;
        killDataSocket();
        break;
      }
      
      if (dataFinished) {
        eventQueue.shift();
        trashQueue = new Array;                                      // clear the trash array, we've successfully completed an 'atomic' set of operations
      }

      if (cmd == "LIST2" && dataFinished) {
        data = parseListData(data, hiddenMode ? parameter.substring(4, parameter.length) : parameter);
        eval(remember);                                              // send off list data to whoever wanted it
      } else if (!dataFinished) {
        setTimeout("readControl(\"2\")", 500);                       // give data stream some time to finish up
        return;
      }
      break;
    case "SIZE":
      if (returnCode == 2) {                                         // used with appe commands to see where to pick up from
        var size = buffer.split(" ");
        size = parseInt(size[1]);
        for (var x = 0; x < eventQueue.length; ++x)
          if (remember == eventQueue[x].cmd) {
            if (remember == "STOR") {
              eventQueue[x].cmd = "APPE";
              eventQueue[x].remember = new Array(eventQueue[x].remember, size);
            }
            if (remember == "APPE")
              eventQueue[x].remember = new Array(eventQueue[x].remember[0], size);
            break;
          }
      } else {                                                       // our size command didn't work out, make sure we're not doing an APPE
        for (var x = 0; x < eventQueue.length; ++x)
          if (eventQueue[x].cmd == "APPE") {
            eventQueue[x].cmd = "STOR";
            eventQueue[x].remember = eventQueue[x].remember[0];
            break;
          }
      }
      break;
    case "RNFR":
    case "REST":
      if (returnCode != 3) {
        if (cmd == "RNFR") {
          eventQueue = new Array;
          trashQueue = new Array;
        }
        error(buffer, true);                                         // should still be able to go on without this, just not with resuming
        break;
      }
      break;
    case "MKD":
    case "SITE CHMOD":
    case "RNTO":
    case "DELE":
    case "RMD":
      if (returnCode != 2)
        error(buffer, true);
      else {
        if (cmd == "RMD" && sessionsMode)                            // clear out of cache if it's a remove directory
          removeCacheEntry(parameter);
        eval(remember);                                              // do the callback function
      }
      trashQueue = new Array;
      break;
    case "CWD":
      if (returnCode != 2) {                                         // if it's not a directory
        var changeDirPath;
        if (eventQueue.length > 1 && eventQueue[1].cmd == "LIST" && eventQueue[1].remember.indexOf("remoteDirTree.changeDir(") != -1)
          changeDirPath = eventQueue[1].remember.substring(eventQueue[1].remember.indexOf("'") + 1, eventQueue[1].remember.length - 2);
        eventQueue.shift();                                          // get rid of pasv and list in the queue
        eventQueue.shift();
        trashQueue = new Array;
        error(buffer, true);
        if (changeDirPath) {                                         // this is a fix for people who can't access '/' on their remote hosts
          gRemotePath.value = changeDirPath;
          remoteDirTree.dontPanic();                                 // don't forget to bring a towel
        }
      } else
        remoteDirTree.changeDir(parameter);                          // else navigate to the directory
      break;
    case "PWD":                                                      // gotta check for chrooted directories
      buffer = buffer.substring(buffer.indexOf("\"") + 1, buffer.lastIndexOf("\""));  // if buffer is not '/' we're chrooted
      remoteDirTree.changeDir(buffer != '/' && initialPath == '/' ? buffer : gRemotePath.value);      // navigate to the directory
      trashQueue = new Array;
      break;
    case "aborted":
      break;
    case "TYPE":
    case "goodbye":                                                  // you say yes, i say no, you stay stop...
    case "NOOP":
    default:
      if (returnCode != 2)
        error(buffer, true);
      break;
  }

  if (suppressQueue)
    return;
  
  isReady = true;
  if (eventQueue.length && eventQueue[0].cmd != "welcome") {        // start the next command
    if (cmd.indexOf("RETR") != -1)
      localRefreshLater = true;
    else if (refreshMode && (cmd.indexOf("STOR") != -1 || cmd.indexOf("APPE") != -1))
      remoteRefreshLater = true;
    writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
  } else if (externalDownloadFile) {                                // if it is an external link from firefox check to see if it's a file to download
    var leafName = externalDownloadFile.substring(externalDownloadFile.lastIndexOf('/') + 1);
    var index = -1;
    for (var x = 0; x < data.length; ++x)
      if (leafName == data[x].leafName) {
        index = x;
        break;
      }

    if (index == -1) {
      externalDownloadFile = "";
      appendLog(strbundle.getString("remoteNoExist"), 'color:red;font-weight:bold;', "error");
      return;
    }
      
    if (data[index].isDirectory) {
      remoteDirTree.changeDir(externalDownloadFile);
      externalDownloadFile = "";
    } else {                                                        // if it is, well, then download it
      externalDownloadFile  = "";
      var prefs             = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
      var prefBranch        = prefs.getBranch("browser.");
      try {
        if (!prefBranch.getBoolPref("download.useDownloadDir"))
          browseLocal(strbundle.getString("saveFileIn"));
      } catch (ex) { }
      remoteTree.selection.select(index);
      transfer(true);
    }
  } else {
    if (localRefreshLater || cmd.indexOf("RETR") != -1) {
      localRefreshLater = false;
      localTree.refresh();
    }
    if (refreshMode && (remoteRefreshLater || cmd.indexOf("STOR") != -1 || cmd.indexOf("APPE") != -1)) {
      remoteRefreshLater = false;
      remoteTree.refresh();
    }
  }
}
function keepAlive() {
  if (isConnected && !dialogOpen && keepAliveMode && eventQueue.length == 0) {
    addEventQueue("NOOP");
    writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
  }
  setTimeout("keepAlive()", 60000);
}
function custom() {
  if (!isConnected)
    return;
  var cmd = window.prompt(strbundle.getString("command"), "", strbundle.getString("customCommand"));
  if (!cmd)
    return;
  addEventQueue(cmd);
  if (isReady)
    writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
}
var suppressQueue = false;
var pauseTrashQueue;
var pauseEventQueue;
function pause() {
  if (!document.getElementById('pausebutton').checked) {             // pause things
    isReady = false;
    
    pauseTrashQueue = new Array();
    pauseEventQueue = new Array();
    for (var x = 0; x < trashQueue.length; ++x)
      pauseTrashQueue.push(trashQueue[x]);
    for (var x = 0; x < eventQueue.length; ++x)
      pauseEventQueue.push(eventQueue[x]);
    eventQueue = new Array();
    trashQueue = new Array();
    
    suppressQueue = true;
    killDataSocket();
  } else {                                                           // resume things
    for (var x = 0; x < pauseTrashQueue.length; ++x)
      trashQueue.push(pauseTrashQueue[x]);
    for (var x = pauseEventQueue.length - 1; x >= 0; --x)
      eventQueue.unshift(pauseEventQueue[x]);

    recoverFromDisaster();
    suppressQueue = false;
    isReady = true;
    if (eventQueue.length && eventQueue[0].cmd != "welcome")
      writeControl(eventQueue[0].cmd, eventQueue[0].parameter);
  }
}
