// this code is mostly from xulplanet.com
var uploadStreamNeedsToBeClosed = false;
var progressEventSink = {
  bytesTotal    : 0,
  sendPrevSent  : 0,
  bytesUploaded : 0,
  timeStart     : new Date(),
  bytesPartial  : 0,
  onTransportStatus : function (transport, status, progress, progressMax) {
    this.bytesUploaded += progress - this.sendPrevSent;
    this.sendPrevSent = progress;
    if (this.bytesUploaded == this.bytesTotal) {         // finished writing
      if (this.bytesTotal)                               // empty files are bad
        uploadStreamNeedsToBeClosed = true;
      else
        emptyFileSoCloseLater = true;
      fileInstream.close();
      dataFinished = true;
      this.bytesTotal = 0;
      return;
    }

    dataOutstream.writeFrom(fileInstream, 4096);
  }
};
window.setInterval("closeUploadStream();", 1000);        // update every half second
function closeUploadStream() {                           // i hate uploading, i hate uploading so much
  if (uploadStreamNeedsToBeClosed) {                     // we get corrupted uploads if we try to close immediately when ssl is enabled
    uploadStreamNeedsToBeClosed = false;
    setTimeout("dataTransport.close('Finished')", 1000);
  }
}
// async read
var dataListener = {
  localpath        : "",
  dataInstream     : "",
  dummy            : "",
  data             : "",
  file             : "",
  fileOutstream    : "",
  binaryOutstream  : "",
  bytesTotal       : 0,
  bytesDownloaded  : 0,
  bytesPartial     : 0,
  timeStart        : new Date(),
  dataBuffer       : "",
  isNotList        : false,
  onStartRequest : function(request, context){
    data = "";
    if (this.isNotList) {
      this.timeStart = new Date();
      try {
        this.file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        this.file.initWithPath(this.localpath);
        this.fileOutstream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                                        .createInstance(Components.interfaces.nsIFileOutputStream);
        if (this.bytesPartial)
          this.fileOutstream.init(this.file, 0x04 | 0x10, 0644, 0);
        else
          this.fileOutstream.init(this.file, 0x04 | 0x08 | 0x20, 0644, 0);
        this.binaryOutstream = Components.classes["@mozilla.org/binaryoutputstream;1"]
                                          .createInstance(Components.interfaces.nsIBinaryOutputStream); 
        this.binaryOutstream.setOutputStream(this.fileOutstream);
      } catch (ex) {
        debug(ex,18);
        error(strbundle.getString("failedSave") + " '" + this.localpath + "' " + strbundle.getString("failedSave2"));
        this.dataInstream.close();
        dataTransport.close("Finished");
        this.binaryOutstream.close();
        this.fileOutstream.close();
        dataFinished = true;
      }
    }
  },
  onStopRequest : function(request, context, status) {
    this.bytesTotal = 0;
    this.dataInstream.close();
    dataTransport.close("Finished");
    if (this.isNotList) {
      this.binaryOutstream.close();
      this.fileOutstream.close();
    }

    data = this.data;
    dataFinished = true;
  },
  onDataAvailable : function(request, context, inputStream, offset, count) {
    if (this.isNotList) {
      try {
        this.dataBuffer = this.dataInstream.readBytes(count);
				this.binaryOutstream.writeBytes(this.dataBuffer, this.dataBuffer.length)
				this.bytesDownloaded += this.dataBuffer.length;
      } catch (ex) {
        debug(ex,19);
        error(strbundle.getString("failedSave") + " '" + this.localpath + "' " + strbundle.getString("failedSave2"));
        this.dataInstream.close();
        dataTransport.close("Finished");
        this.binaryOutstream.close();
        this.fileOutstream.close();
        dataFinished = true;
      }
    } else
      this.data += this.dataInstream.readBytes(this.dataInstream.available());
  }
};
function dataSocketConnect(write, localpath, fileTotalBytes, filePartialBytes, activeTransport) {
  // create a data socket
  try {
    if (pasvMode) {
      var transportService = Components.classes["@mozilla.org/network/socket-transport-service;1"]
                                       .getService(Components.interfaces.nsISocketTransportService);

      var proxyInfo = null;
    
      if (proxyType != "") {
        var proxyService = Components.classes["@mozilla.org/network/protocol-proxy-service;1"]
                                     .getService(Components.interfaces.nsIProtocolProxyService);
        proxyInfo = proxyService.newProxyInfo(proxyType, proxyHost, proxyPort, 0, 30, null);
      }
    
      if (security && protPSuccess)
        dataTransport = transportService.createTransport(["ssl"], 1, dataHost, dataPort, proxyInfo);
      else
        dataTransport = transportService.createTransport(null, 0, dataHost, dataPort, proxyInfo);
    } else
      dataTransport = activeTransport;

    if (write)  { // upload a file
      dataFinished = false;
      dataOutstream = dataTransport.openOutputStream(0,0,-1);

      // open the file
      var file;
      try {
        file = Components.classes['@mozilla.org/file/local;1']
                         .createInstance(Components.interfaces.nsILocalFile);
        file.initWithPath(localpath);
        fileInstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                                  .createInstance();
        fileInstream.QueryInterface(Components.interfaces.nsIFileInputStream);
        fileInstream.init(file, 0x01, 0644, 0);
        fileInstream.QueryInterface(Components.interfaces.nsISeekableStream);
        fileInstream.seek(0, filePartialBytes);  // append or not to append
      } catch (ex) {
        debug(ex,16);
        error(strbundle.getString("failedUpload") + " '" + localpath + "'.");
        dataOutstream.close();
        dataTransport.close("Finished");
        fileInstream.close();
        dataFinished = true;
      }

      uploadStreamNeedsToBeClosed = false;
      progressEventSink.sendPrevSent  = 0;
      progressEventSink.timeStart     = new Date();
      progressEventSink.bytesTotal    = file.fileSize;
      progressEventSink.bytesUploaded = parseInt(filePartialBytes);
      progressEventSink.bytesPartial  = parseInt(filePartialBytes);
      dataTransport.setEventSink(progressEventSink,null);
      dataOutstream.writeFrom(fileInstream, 4096);

    } else { // read data
      dataFinished = false;
      var dataStream   = dataTransport.openInputStream(0,0,0);
      var dataInstream = Components.classes["@mozilla.org/binaryinputstream;1"]
                                   .createInstance(Components.interfaces.nsIBinaryInputStream);
      dataInstream.setInputStream(dataStream);

      fileTotalBytes   = fileTotalBytes   ? fileTotalBytes   : 0;
      filePartialBytes = filePartialBytes ? filePartialBytes : 0;

      dataListener.localpath        = localpath;
      dataListener.dataInstream     = dataInstream;
      dataListener.dummy            = "";
      dataListener.data             = "";
      dataListener.file             = "";
      dataListener.fileOutstream    = "";
      dataListener.binaryOutstream  = "";
      dataListener.bytesTotal       = fileTotalBytes;
      dataListener.bytesDownloaded  = filePartialBytes;
      dataListener.bytesPartial     = filePartialBytes;
      dataListener.timeStart        = new Date();
      dataListener.dataBuffer       = "";
      dataListener.isNotList        = eventQueue[0].cmd.indexOf("LIST") == -1;

      var pump = Components.classes["@mozilla.org/network/input-stream-pump;1"]
                           .createInstance(Components.interfaces.nsIInputStreamPump);
      pump.init(dataStream, -1, -1, 0, 0, false);
      pump.asyncRead(dataListener,null);
    }
    
  } catch(ex) {
    error(strbundle.getString("errorDataConn"));
    debug(ex,20);
    return;
  }
}
function killDataSocket() {
  progressEventSink.bytesTotal = 0;                                       // stop uploads
  dataListener.bytesTotal      = 0;                                       // stop downloads

  dataFinished = true;

  try {
    dataInstream.close();
  } catch(ex) { }
  try {
    dataOutstream.close();
  } catch(ex) { }
  try {
    dataTransport.close("Finished");
  } catch(ex) { }
  try {
    fileInstream.close();
  } catch(ex) { }
  try {
    fileOustream.close();
  } catch(ex) { }
}
