var strbundle;
function init(aEvent) {
  strbundle = document.getElementById("strings");
  for (var x = 0; x < window.arguments[0].length; ++x)  // local files
    constructRow(window.arguments[0][x].file, strbundle.getString("diffMissingLocal"), window.arguments[0][x].action, "local" + x, "upload");
  for (var x = 0; x < window.arguments[1].length; ++x)  // remote files
    constructRow(window.arguments[1][x].file, strbundle.getString("diffMissingRemote"), window.arguments[1][x].action, "remote" + x, "download");
  for (var x = 0; x < window.arguments[2].length; ++x)  // files with different sizes
    constructRow(window.arguments[2][x].localFile, window.arguments[2][x].reason, window.arguments[2][x].action, "nothing" + x);
}
function constructRow(file, reason, action, id, disable) {
  var row = document.createElement("row");
  document.getElementById('main').appendChild(row);

  var vbox1 = document.createElement("vbox");
  vbox1.setAttribute("style",
      "border-left: 1px solid black; border-bottom: 1px solid black; border-right: 1px solid black; background-color:white;");
  row.appendChild(vbox1);

  var vbox2 = document.createElement("vbox");
  vbox2.setAttribute("style",
      "border-bottom: 1px solid black; border-right: 1px solid black; background-color:white;");
  row.appendChild(vbox2);

  var vbox3 = document.createElement("vbox");
  vbox3.setAttribute("style",
      "border-bottom: 1px solid black; border-right: 1px solid black; background-color:white;");
  row.appendChild(vbox3);

  var spacer1 = document.createElement("spacer");
  spacer1.setAttribute("style", "height:5px");
  vbox1.appendChild(spacer1);

  var spacer2 = document.createElement("spacer");
  spacer2.setAttribute("style", "height:5px");
  vbox2.appendChild(spacer2);

  var label1 = document.createElement("label");
  label1.setAttribute("value", file.leafName);
  vbox1.appendChild(label1);

  var label2 = document.createElement("label");
  label2.setAttribute("value", reason);
  vbox2.appendChild(label2);

  var menulist = document.createElement("menulist");
  menulist.setAttribute("id", id);
  menulist.setAttribute("label",
      action == "download" ? strbundle.getString("download")
        : (action == "upload" ? strbundle.getString("upload") : strbundle.getString("donothing")));
  menulist.setAttribute("value", action);
  vbox3.appendChild(menulist);

  var menupopup = document.createElement("menupopup");
  menulist.appendChild(menupopup);

  if (!disable || disable != "download") {
    var menuitem1 = document.createElement("menuitem");
    menuitem1.setAttribute("label", strbundle.getString("download"));
    menuitem1.setAttribute("value", "download");
    if (action == "download")
      menuitem1.setAttribute("selected", "true");
    menupopup.appendChild(menuitem1);
  }

  if (!disable || disable != "upload") {
    var menuitem2 = document.createElement("menuitem");
    menuitem2.setAttribute("label", strbundle.getString("upload"));
    menuitem2.setAttribute("value", "upload");
    if (action == "upload")
      menuitem2.setAttribute("selected", "true");
    menupopup.appendChild(menuitem2);
  }

  var menuitem3 = document.createElement("menuitem");
  menuitem3.setAttribute("label", strbundle.getString("donothing"));
  menuitem3.setAttribute("value", "nothing");
  if (action == "nothing")
    menuitem3.setAttribute("selected", "true");
  menupopup.appendChild(menuitem3);
}
function parseList() {
  window.arguments[3].value = true;     // return value of this dialog

  for (var x = 0; x < window.arguments[0].length; ++x)
    window.arguments[0][x].action = document.getElementById("local" + x).value;
  for (var x = 0; x < window.arguments[1].length; ++x)
    window.arguments[1][x].action = document.getElementById("remote" + x).value;
  for (var x = 0; x < window.arguments[2].length; ++x)
    window.arguments[2][x].action = document.getElementById("nothing" + x).value;

  return true;
}
