window.setInterval("UIUpdate()", 1000);            // update once a second
var statusBarClear = true;
function UIUpdate() {
  if (queuedLogData && logMode) {
    var scrollLog = gCmdlogBody.scrollTop + 50 >= gCmdlogBody.scrollHeight - gCmdlogBody.clientHeight;
    gCmdlogBody.innerHTML += queuedLogData;                            // update log
    if (scrollLog)
      gCmdlogBody.scrollTop = gCmdlogBody.scrollHeight - gCmdlogBody.clientHeight;  // scroll to bottom
    queuedLogData = "";

    var cmdlogDocument = document.getElementById('cmdlog').contentWindow.document;
    var nodeList = cmdlogDocument.getElementsByTagName("div");         // don't keep too much log data or it will slow down things
    while (nodeList.length > 200) {
      for (var x = 0; x < nodeList.length; ++x)
        if (nodeList.item(x).getAttribute("id") != "mousePressed" && nodeList.item(x).getAttribute("id") != "mouseY") {
          gCmdlogBody.removeChild(nodeList.item(x));
          break;
        }
    }
  }
  
  var bytesTotal;                                                      // update status bar
  var bytesTransferred;
  var bytesPartial;
  var timeStart;
  if (progressEventSink.bytesTotal) {
    bytesTotal       = progressEventSink.bytesTotal;
    bytesTransferred = progressEventSink.bytesUploaded;
    bytesPartial     = progressEventSink.bytesPartial;
    timeStart        = progressEventSink.timeStart;
  } else if (dataListener.bytesTotal) {
    bytesTotal       = dataListener.bytesTotal;
    bytesTransferred = dataListener.bytesDownloaded;
    bytesPartial     = dataListener.bytesPartial;
    timeStart        = dataListener.timeStart;
  }

  if (bytesTotal) {
    ++networkTimeoutID;
    setTimeout("checkTimeout(" + networkTimeoutID + ", '', true)", network * 1000);

    statusBarClear    = false;
    var timeElapsed   = ((new Date()) - timeStart) / 1000;
    timeElapsed       = timeElapsed != 0 ? timeElapsed : 1;            // no dividing by 0
    var averageRate   = ((bytesTransferred - bytesPartial) / 1024 / timeElapsed).toFixed(2);
    averageRate       = averageRate != 0 ? averageRate : 0.00001;      // no dividing by 0
    var timeRemaining = (bytesTotal - bytesTransferred) / 1024 * (1 / averageRate);

    averageRate += " KB/s";
    var filesleft = 1;
    for (var x = 0; x < eventQueue.length; ++x)
      if (eventQueue[x].cmd == "RETR" || eventQueue[x].cmd == "APPE"
          || eventQueue[x].cmd == "STOR")
        ++filesleft;
    document.getElementById('statusbytes').label =
        commas(bytesTransferred) + " / " + commas(bytesTotal) + ' - ' +
        filesleft + ' ' + strbundle.getString("filesleft");
    var hours = parseInt(timeElapsed / 3600);
    var min   = parseInt((timeElapsed - hours * 3600) / 60);
    var sec   = parseInt(timeElapsed - hours * 3600 - min * 60);
    document.getElementById('statuselapsed').label = zeros(hours) + ":" + zeros(min) + ":" + zeros(sec);

    hours = parseInt(timeRemaining / 3600);
    min   = parseInt((timeRemaining - hours * 3600) / 60);
    sec   = parseInt(timeRemaining - hours * 3600 - min * 60);
    document.getElementById('statusremaining').label = zeros(hours) + ":" + zeros(min) + ":" + zeros(sec);

    document.getElementById('statusrate').label = averageRate;
    var total = bytesTotal != 0 ? bytesTotal : 1;                      // no dividing by 0
    document.getElementById('statusmeter').setAttribute("mode", "determined");
    var progress = parseInt(bytesTransferred / total * 100) + "%";
    document.getElementById('statusmeter').setAttribute("value", progress);
    document.title = progress + " @ " + averageRate + " - "
      + (account ? account : host) + " - FireFTP";
  } else {
    var filesleft = 0;                                                 // update status bar to list how many files are left
    for (var x = 0; x < eventQueue.length; ++x)
      if (eventQueue[x].cmd == "RETR" || eventQueue[x].cmd == "APPE"
          || eventQueue[x].cmd == "STOR" || eventQueue[x].cmd == "DELE" || eventQueue[x].cmd == "RMD")
        ++filesleft;
    var status = "";
    if (filesleft) {
      status = strbundle.getString("working") + ' - ' + filesleft + ' ' + strbundle.getString("filesleft");
      document.getElementById('statusmeter').setAttribute("mode", "undetermined");
      statusBarClear = false;
    } else if (eventQueue.length) {
      status = eventQueue[0].cmd == "welcome" ? strbundle.getString("connecting") : strbundle.getString("working");
      document.getElementById('statusmeter').setAttribute("mode", "undetermined");
      statusBarClear = false;
    } else if (!statusBarClear) {
      document.getElementById('statusmeter').setAttribute("mode", "determined");
      statusBarClear = true;
    } else if (statusBarClear)
      return;

    if (!isReconnecting && !isConnected && !document.getElementById('abortbutton').disabled)
      document.getElementById('abortbutton').disabled = true;

    if (isReconnecting)
      status = strbundle.getString("reconnect") + ' ' + retry + ' ' + strbundle.getString("seconds") +
          ' ' + reconnectAttempts + ' ' + strbundle.getString("attempts");

    document.getElementById('statusbytes').label = status;
    if (!isConnected) {
      document.title = (isReconnecting ? (status + " - ") : "") + "FireFTP";
      statusBarClear = false;
    } else
      document.title = status + (status == "" ? "" : " - ") + (account ? account : host) + " - FireFTP";
    document.getElementById('statuselapsed').label = "";
    document.getElementById('statusremaining').label = "";
    document.getElementById('statusrate').label = "";
    document.getElementById('statusmeter').setAttribute("value", "0%");
  }
}
