function commas(num) {                 // add commas to numbers
  num = num.toString();
  if (num.search(/\d{4}$/) == -1)
    return num;
  num = num.replace(/\d{3}$/, ",$&");
  while (num.search(/\d{4}\x2C/) != -1)
    num = num.replace(/\d{3}\x2C/, ",$&");
  return num;
}
function zeros(num) {                  // pad with zeros
  num = num.toString();
  if (num.length == 1)
    num = "0" + num;
  return num;
}
function setInterfaceMode() {          // update the interface based on collapsing
  interfaceMode = (document.getElementById('leftsplitter').getAttribute('state') == 'collapsed') * 2 +
    (document.getElementById('rightsplitter').getAttribute('state') == 'collapsed')
  savePreferences();
  
  updateInterface();
}
function updateInterface() {           // update the interface based on interfacemode variable
  var local = (interfaceMode & 2);
  var remote = (interfaceMode & 1);
  
  document.getElementById('leftsplitter').setAttribute('state', (local ? 'collapsed' : 'open'));
  document.getElementById('rightsplitter').setAttribute('state', (remote ? 'collapsed' : 'open'));
  
  document.getElementById('localview').collapsed  = local;
  document.getElementById('remoteview').collapsed = remote;

  document.getElementById('leftsplitter').setAttribute('collapse', (remote ? 'none' : 'before'));  
  document.getElementById('rightsplitter').setAttribute('collapse', (local ? 'none' : 'after'));
  
  document.getElementById('leftgrippy').collapsed  = remote;
  document.getElementById('rightgrippy').collapsed = local;

  document.getElementById('storbutton').collapsed = local;
  document.getElementById('retrbutton').collapsed = remote;
}


var localPathFocus;                    // these functions are to keep the correct value in the paths
function onLocalPathFocus(event) {
  localPathFocus = gLocalPath.value;
}
function onLocalPathBlur(event) {
  gLocalPath.value = localPathFocus;
}
var remotePathFocus;
function onRemotePathFocus(event) {
  remotePathFocus = gRemotePath.value;
}
function onRemotePathBlur(event) {
  if (!isConnected)
    remotePathFocus = gRemotePath.value;
  else
    gRemotePath.value = remotePathFocus;
}

function browseLocal(title) {          // browser the local file structure
  var nsIFilePicker = Components.interfaces.nsIFilePicker;
  var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
  fp.init(window, title ? title : strbundle.getString("selectFolder"), nsIFilePicker.modeGetFolder);
  var res = fp.show();
  if (res == nsIFilePicker.returnOK)
    localDirTree.changeDir(fp.file.path);
}
function parseSize(size) {             // adds byte information for file sizes
  if (size > 1024 * 1024 * 1024)
    size = parseFloat(size / 1024 / 1024 / 1024).toFixed(1) + " GB";
  else if (size > 1024 * 1024)
    size = parseFloat(size / 1024 / 1024).toFixed(1) + " MB";
  else if (size > 1024)
    size = parseFloat(size / 1024).toFixed(1) + " KB";
  else
    size = size + " Bytes";
  return size;
}

function displayWelcomeMessage() {
  if (welcomeMode) {
    if (welcomeWindow) {               // get rid of those extra pestering welcome windows if the program is reconnecting automatically
      try {
        welcomeWindow.close();
      } catch (ex) { }
    }
    welcomeWindow = window.openDialog("chrome://fireftp/content/welcome.xul","welcome",
      "width=400,height=200,chrome,modal=no,dialog=no,resizable=yes,centerscreen", welcomeMessage);
  }
}

function runInFirefox(path) {
  try {
    var firefoxInstallPath = Components.classes["@mozilla.org/file/directory_service;1"]
                                       .createInstance(Components.interfaces.nsIProperties)
                                       .get("CurProcD", Components.interfaces.nsIFile);
    var firefox = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    firefox.initWithPath(firefoxInstallPath.path + "\\" + "firefox.exe");

    if (!firefox.exists()) {                                 // try linux
      firefox.initWithPath(firefoxInstallPath.path + "/" + "firefox");
      if (!firefox.exists())                                 // try os x
         firefox.initWithPath(firefoxInstallPath.path + "/" + "firefox-bin");
    }

    var process = Components.classes['@mozilla.org/process/util;1'].getService(Components.interfaces.nsIProcess);
    process.init(firefox);
    var arguments = [];

    arguments.push(path);

    process.run(false, arguments, arguments.length, {});
  } catch (ex) {
    debug(ex, 108);
  }
}

function tipJar() {
  if (!donated) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                                  .getService(Components.interfaces.nsIPromptService);
    var flags = promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_0 +
                promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_1 +
                promptService.BUTTON_TITLE_IS_STRING * promptService.BUTTON_POS_2;
    var response = promptService.confirmEx(window, strbundle.getString("donatedTitle"),
          strbundle.getString("donated"), flags,
          strbundle.getString("donateButton"),
          strbundle.getString("noThanksButton"),
          strbundle.getString("remindMeButton"), null, {});
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    var prefBranch = prefs.getBranch("fireftp.");
    if (response == 0) {
      runInFirefox("http://fireftp.mozdev.org/donate.html");
      prefBranch.setBoolPref("donated", true);
    } else if (response == 1) {
      prefBranch.setBoolPref("donated", true);
    }
  }
}
