function createAccount() {
  if (!siteManager.length) {
    newSite();
  }
}
function newSite() {
  var params = { returnVal  : false,
                 localPath  : gLocalPath.value,
                 remotePath : gRemotePath.value,
                 site       : { account: "", host: "", port: 21, login: "", password: "",
                                anonymous: false, security: "", pasvmode: true,
                                localdir: "", remotedir: "", webhost: "", downloadcasemode: 0, uploadcasemode: 0 } };

  while (true) {                                                     // open up the Site Manager
    params.returnVal = false;
    window.openDialog("chrome://fireftp/content/accountManager.xul","accountManager",
      "width=375,height=350,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);

    if (!params.returnVal)
      return;
    var siteFound = false;                                           // make sure we don't have a duplicate
    for (var x = 0; x < siteManager.length; ++x) {
      if (siteManager[x].account == params.site.account) {
        siteFound = true;
        break;
      }
    }

    if (siteFound) {                                                 // we have a duplicate
      window.openDialog("chrome://fireftp/content/alert.xul","alert",
        "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", strbundle.getString("dupAccount"));
      continue;
    } else
      break;
  }

  siteManager.push(params.site);

  if (passwordMode) {
    var host     = {value:""};
    var login    = {value:""};
    var password = {value:""};

    try {                                                            // save username & password
      var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
      var passManagerIn = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);

      var recordedHost = (params.site.host.indexOf("ftp.") == 0 ? '' : "ftp.") + params.site.host;

      if (passwordMode)
        passManager.addUser(recordedHost, params.site.login, params.site.password);
    } catch (ex) { debug(ex,11); }
  }

  var tempPassword = params.site.password;
  saveSiteManager();                                                 // save site manager
  loadSiteManager();

  for (var x = 0; x < siteManager.length; ++x) {                     // select the new site
    if (siteManager[x].account == params.site.account) {
      document.getElementById('account').selectedIndex = x;
      siteManager[x].password = tempPassword;                        // if "Remember Passwords" is off we have to remember what it is temporarily
      onAccountChange();
      break;
    }
  }
}
function cloneObject(what) {
    for (i in what) {
        this[i] = what[i];
    }
}
function editSite() {
  if (!document.getElementById('account').value)
    return;

  var site;                                                          // grab a copy of the old site
  for (var x = 0; x < siteManager.length; ++x) {
    if (siteManager[x].account == document.getElementById('account').value) {
      site = new cloneObject(siteManager[x]);
      break;
    }
  }
  var oldSite = new cloneObject(site);

  var params = { returnVal    : false,
                 localPath    : gLocalPath.value,
                 remotePath   : gRemotePath.value,
                 site         : site };

  while (true) {                                                     // open up the site manager
    params.returnVal = false;
    window.openDialog("chrome://fireftp/content/accountManager.xul","accountManager",
      "width=375,height=350,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);
    if (!params.returnVal)
      return;
    if (params.site.account != oldSite.account) {                           // make sure we don't have a duplicate account
      var siteFound = false;
      for (var x = 0; x < siteManager.length; ++x) {
        if (siteManager[x].account == params.site.account) {
          siteFound = true;
          break;
        }
      }
      if (siteFound) {                                               // we have a duplicate
        window.openDialog("chrome://fireftp/content/alert.xul","alert",
          "width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", strbundle.getString("dupAccount"));
        continue;
      }
    }                                                                // replace the old with the new
    for (var x = 0; x < siteManager.length; ++x) {
      if (siteManager[x].account == oldSite.account) {
        siteManager[x] = params.site;
        break;
      }
    }
    break;
  }

  try {                                                              // delete old password from list
    var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
    var recordedHost = (oldSite.host.indexOf("ftp.") == 0 ? '' : "ftp.") + oldSite.host;
    passManager.removeUser(recordedHost, oldSite.login);
  } catch (ex) { }

  if (passwordMode) {
    var host     = {value:""};
    var login    = {value:""};
    var password = {value:""};

    try {
      var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
      var passManagerIn = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);

        var recordedHost = (params.site.host.indexOf("ftp.") == 0 ? '' : "ftp.") + params.site.host;

        if (passwordMode)                                            // save username & password
          passManager.addUser(recordedHost, params.site.login, params.site.password);
    } catch (ex) { debug(ex,11); }
  }

  var tempPassword = params.site.password;
  saveSiteManager();                                                 // save site manager
  loadSiteManager();

  for (var x = 0; x < siteManager.length; ++x) {                     // select the newly edited site
    if (siteManager[x].account == params.site.account) {
      document.getElementById('account').selectedIndex = x;
      siteManager[x].password = tempPassword;                        // if "Remember Passwords" is off we have to remember what it is temporarily
      onAccountChange();
      break;
    }
  }
}
function deleteSite() {
  if (!document.getElementById('account').value)
    return;
    
  if (!confirm(strbundle.getString("confirmDelete") + " '" + document.getElementById('account').value + "'?"))
    return;

  for (var x = 0; x < siteManager.length; ++x) {                     // delete the account
    if (siteManager[x].account == document.getElementById('account').value) {
      try {                                                          // delete password from list
        var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManager);
        var recordedHost = (siteManager[x].host.indexOf("ftp.") == 0 ? '' : "ftp.") + siteManager[x].host;
        passManager.removeUser(recordedHost,siteManager[x].login);
      } catch (ex) { }
        siteManager.splice(x, 1);
      break;
    }
  }
  saveSiteManager();
  loadSiteManager();
}
function quickConnect() {                                            // make a quick connection, account not saved
  var params = { returnVal    : false,
                 quickConnect : true,
                 localPath    : gLocalPath.value,
                 remotePath   : gRemotePath.value,
                 site         : { account: "", host: "", port: 21, login: "", password: "",
                                  anonymous: false, security: "", pasvmode: true,
                                  localdir: "", remotedir: "", webhost: "", downloadcasemode: 0, uploadcasemode: 0 } };

  window.openDialog("chrome://fireftp/content/accountManager.xul","accountManager",
    "width=375,height=350,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);

  if (!params.returnVal)
    return;

  accountChangeHelper(params.site);
  controlSocketConnect(true, true);
}
function externalLink() {                                            // opened up fireFTP using a link in Firefox
  var params = { returnVal  : false,
                 localPath  : gLocalPath.value,
                 remotePath : gRemotePath.value,
                 site       : { account: "", host: "", port: 21, login: "anonymous", password: "fireftp@example.com",
                                anonymous: true, security: "", pasvmode: true,
                                localdir: "", remotedir: "", webhost: "", downloadcasemode: 0, uploadcasemode: 0 } };

  var uri = Components.classes["@mozilla.org/network/standard-url;1"].getService(Components.interfaces.nsIURI);
  uri.spec = loadUrl;

  if (!uri.schemeIs("ftp") || loadUrl.length <= 6)                   // sanity check
    return;

  if (uri.username) {
    params.site.login     = unescape(uri.username);
    params.site.password  = unescape(uri.password);
    params.site.anonymous = params.site.login ? true : false;
  }

  params.site.host      = uri.host;
  params.site.port      = uri.port == -1 ? 21 : uri.port;

  
  var prefs             = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
  var prefBranch        = prefs.getBranch("browser.");
  externalDownloadFile  = uri.path.charAt(uri.path.length - 1) == '/' ? "" : unescape(uri.path);
  try {
    if (prefBranch.getBoolPref("download.useDownloadDir"))
      params.site.localdir  = prefBranch.getCharPref("download.dir");
  } catch (ex) { }
  params.site.remotedir = externalDownloadFile == "" ? unescape(uri.path) : unescape(uri.path.substring(0, uri.path.lastIndexOf('/')));

  loadUrl = "";                                                      // clear out loadUrl
  prefBranch = prefs.getBranch("fireftp.");
  prefBranch.setCharPref("loadurl", "");

  document.getElementById('account').setAttribute("label", strbundle.getString("tempAccount"));

  accountChangeHelper(params.site);
  controlSocketConnect(true, true);                                  // connect!
}
function onAccountChange() {
  var accountToLoad = isConnected ? account : document.getElementById('account').value;

  for (var x = 0; x < siteManager.length; ++x) {                     // load up the new values into the global variables
    if (siteManager[x].account == accountToLoad) {
      accountChangeHelper(siteManager[x]);
      break;
    }
  }
}
function accountChangeHelper(site) {
  account        = site.account;
  host           = site.host;
  port           = site.port;
  login          = site.login;
  password       = site.password;
  anonymousLogin = site.anonymous;
  security       = site.security;
  pasvMode       = site.pasvmode;
  if (!isConnected) {
    if (site.localdir)
      localDirTree.changeDir(site.localdir);
    if (site.remotedir)
      gRemotePath.value = site.remotedir;
    else
      gRemotePath.value = "/";
  }
  webHost          = site.webhost;
  downloadCaseMode = site.downloadcasemode;
  uploadCaseMode   = site.uploadcasemode;

  accountButtonsDisabler(false);
}
function accountButtonsDisabler(enable) {
  document.getElementById('editMenuItem').setAttribute("disabled", enable);
  document.getElementById('deleteMenuItem').setAttribute("disabled", enable);
  if (!isConnected)
    document.getElementById('connectbutton').disabled = enable;
}
function connectedButtonsDisabler() {
  document.getElementById('abortbutton').disabled = !isConnected;
  document.getElementById('pausebutton').disabled = !isConnected;
  document.getElementById('customMenuItem').setAttribute("disabled", !isConnected);
  document.getElementById('diffMenuItem').setAttribute("disabled", !isConnected);
}
function loadSiteManager() {
  // read siteManager data
  try {
    document.getElementById('account').removeAllItems();
    if (!isConnected) {
      account           = "";
      host              = "";
      port              = 21;
      login             = "";
      password          = "";
      anonymousLogin    = false;
      security          = "";
      pasvMode          = true;
      gRemotePath.value = "/";
      webHost           = "";
      downloadCaseMode  = 0;
      uploadCaseMode    = 0;
    }

    var profD = Components.classes["@mozilla.org/file/directory_service;1"]
                          .createInstance(Components.interfaces.nsIProperties)
                          .get("ProfD", Components.interfaces.nsIFile);
    var file = Components.classes['@mozilla.org/file/local;1']
                         .createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(profD.path + slash + "fireFTPsites.dat");

    if (!file.exists())
      siteManager = new Array();
    else {
      var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
                              .createInstance(Components.interfaces.nsIFileInputStream);
      var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
                              .createInstance(Components.interfaces.nsIScriptableInputStream);
      fstream.init(file, 1, 0, false);
      sstream.init(fstream); 

      var siteData = "";
      var str = sstream.read(-1);
      while (str.length > 0) {
        siteData += str;
        str = sstream.read(-1);
      }

      siteManager = eval(siteData);

      if (passwordMode) {
        for (var x = 0; x < siteManager.length; ++x) {               // retrieve passwords from passwordmanager
          try {
            var host = {value:""};    var login =  {value:""};    var password = {value:""}; 
            var passManager = Components.classes["@mozilla.org/passwordmanager;1"].getService(Components.interfaces.nsIPasswordManagerInternal);

            passManager.findPasswordEntry((siteManager[x].host.indexOf("ftp.") == 0 ? '' : "ftp.")
              + siteManager[x].host, siteManager[x].login, "", host, login, password);

            siteManager[x].password = password.value;
          } catch (ex) { }
        }
      }

      sstream.close();
      fstream.close();

      for (var x = 0; x < siteManager.length; ++x)
        document.getElementById('account').appendItem(siteManager[x].account, siteManager[x].account);
    }

    if (siteManager.length)
      document.getElementById('account').setAttribute("label", strbundle.getString("chooseAccount"));
    else
      document.getElementById('account').setAttribute("label", strbundle.getString("noAccounts"));
    accountButtonsDisabler(true);
  } catch (ex) {
    debug(ex, 43);
  }
}
function saveSiteManager() {
  // write siteManager out to disk
  try {
    var tempSiteManagerArray = new Array();
    for (var x = 0; x < siteManager.length; ++x) {
      tempSiteManagerArray.push(new cloneObject(siteManager[x]));
    }
    for (var x = 0; x < tempSiteManagerArray.length; ++x) {          // we don't save out the passwords, those are saved in the passwordmanager
      tempSiteManagerArray[x].password = "";
    }

    var profD = Components.classes["@mozilla.org/file/directory_service;1"]
                          .createInstance(Components.interfaces.nsIProperties)
                          .get("ProfD", Components.interfaces.nsIFile);
    var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(profD.path + slash + "fireFTPsites.dat");
    var foutstream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                               .createInstance(Components.interfaces.nsIFileOutputStream);
    foutstream.init(file, 0x04 | 0x08 | 0x20, 0644, 0);
    tempSiteManagerArray.sort(compareAccount);
    foutstream.write(tempSiteManagerArray.toSource(), tempSiteManagerArray.toSource().length);
    foutstream.close();
  } catch (ex) {
    debug(ex, 44);
  }
}
function saveSession() {
  var newConnectedHost = login + "@" + host;
  if (isConnected && newConnectedHost != connectedHost) {            // switching to a different host or different login
    connectedHost = newConnectedHost;
    remoteTree.treebox.rowCountChanged(0, -remoteTree.rowCount);
    remoteTree.rowCount = 0;
    remoteTree.data = new Array();
    remoteDirTree.treebox.rowCountChanged(0, -remoteDirTree.rowCount);
    remoteDirTree.rowCount = 0;
    remoteDirTree.data = new Array();
  }
}
function removeCacheEntry(path) {                                    // does just that
  try {
    var cacheService = Components.classes["@mozilla.org/network/cache-service;1"]
                                 .getService(Components.interfaces.nsICacheService);
    var cacheSession = cacheService.createSession("fireftp", 0, true);
    var cacheDesc = cacheSession.openCacheEntry("ftp://" + version + connectedHost + path,
                                                Components.interfaces.nsICache.ACCESS_WRITE, false);
    cacheDesc.doom();
    cacheDesc.close();
  } catch (ex) { debug(ex,15); }
}
