var treeHighlighter = {
  mouseDownRow     : 0,
  mouseDownPressed : 0,
  mouseDirection   : 0,
  mousePreviousY   : 0,
  validChildren    : new Array,
  validTrees       : new Array,
  validColumns     : new Array,
  found            : -1,
  mouseDown : function(event) {                                // record the start position
    this.found = -1;
    for (var x = 0; x < this.validChildren.length; ++x)
      if (event.target == this.validChildren[x]) {
        this.found = x;
        break;
      }
    if (this.found == -1)
      return;

    this.mouseDownPressed = true;
    this.mousePreviousY = event.pageY;

    var rowValueNeg = false;
    var row = {};    var col = {};    var child = {};
    this.validTrees[this.found].treeBoxObject.getCellAt(event.pageX, event.pageY, row, col, child);
    if (row.value == -1) {                                     // this is if we click in the white space below the available rows
      this.validTrees[this.found].view.selection.clearSelection();
      row.value = this.validTrees[this.found].view.rowCount - 1;
      rowValueNeg = true;
    }
    this.mouseDownRow = row.value;
    
    var x = {};    var y = {};    var width = {};    var height = {};
    this.validTrees[this.found].treeBoxObject.getCoordsForCellItem(row.value, this.validTrees[this.found].columns[this.validColumns[this.found]], "text", x, y, width, height);
    dragSessionEnabled = !rowValueNeg && event.pageX - this.validChildren[this.found].boxObject.x < x.value + width.value; // drag enabled if mouse over name
  },
  mouseMove : function(event, hack) {                          // change the selection depending on mouse movement
                                                               // XXX we need 'hack' to get mouse events from the log window
    if (hack)
      event = { pageY: hack, pageX: 0 };
    else {
      document.getElementById('cmdlog').contentWindow.document.getElementById('mouseY').innerHTML = previousMousePos;
      document.getElementById('cmdlog').contentWindow.document.getElementById('mousePressed').innerHTML = "null";
    }

    if (this.found != -1 && this.mouseDownPressed && !event.ctrlKey && !event.shiftKey && !dragSessionEnabled) {
      if (this.mousePreviousY)
        this.mouseDirection = event.pageY - this.mousePreviousY > 0 ? true : false;
      this.mousePreviousY = event.pageY;
      if (event.pageY < this.validChildren[this.found].boxObject.y) {      // we need to do some scrolling
        this.extendSelectionUpwards();
        return;
      } else if (event.pageY > this.validChildren[this.found].boxObject.y + this.validChildren[this.found].boxObject.height) {
        this.extendSelectionDownwards();
        return;
      }
      var row = {};    var col = {};    var child = {};
      this.validTrees[this.found].treeBoxObject.getCellAt(event.pageX, event.pageY, row, col, child);
      if (row.value == -1)                                     // this is if we are in the white space below the available rows
        row.value = this.validTrees[this.found].treeBoxObject.getLastVisibleRow();
      this.validTrees[this.found].view.selection.rangedSelect(this.mouseDownRow, row.value, false);
    }
  },
  mouseUp : function(event) {                                  // finish up
    this.mouseDownPressed = false;
  },
  extendSelectionUpwards : function() {                        // scrolling up while highlighting files
    if (this.mouseDirection || !this.mouseDownPressed)
      return;
    if (this.validTrees[this.found].treeBoxObject.getFirstVisibleRow() == 0) {        // we've hit the top of the list
      this.validTrees[this.found].view.selection.rangedSelect(this.mouseDownRow, this.validTrees[this.found].treeBoxObject.getFirstVisibleRow(), false);
      return;
    }
    this.validTrees[this.found].treeBoxObject.ensureRowIsVisible(this.validTrees[this.found].treeBoxObject.getFirstVisibleRow() - 1);
    this.validTrees[this.found].view.selection.rangedSelect(this.mouseDownRow, this.validTrees[this.found].treeBoxObject.getFirstVisibleRow(), false);
    if (this.mouseDownPressed)
      setTimeout("treeHighlighter.extendSelectionUpwards()", 100);
  },
  extendSelectionDownwards : function() {                      // scrolling down while highlighting files
    if (!this.mouseDirection || !this.mouseDownPressed)
      return;                                                  // we've hit the bottom of the list
    if (this.validTrees[this.found].view.rowCount - 1 < this.validTrees[this.found].treeBoxObject.getLastVisibleRow()) {
      this.validTrees[this.found].view.selection.rangedSelect(this.mouseDownRow, this.validTrees[this.found].treeBoxObject.getLastVisibleRow(), false);
      return;
    }
    this.validTrees[this.found].treeBoxObject.ensureRowIsVisible(this.validTrees[this.found].treeBoxObject.getLastVisibleRow() + 1);
    this.validTrees[this.found].view.selection.rangedSelect(this.mouseDownRow, this.validTrees[this.found].treeBoxObject.getLastVisibleRow(), false);
    if (this.mouseDownPressed)
      setTimeout("treeHighlighter.extendSelectionDownwards()", 100);
  }
};
