var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
var localTree = {
  data        : new Array,
  displayData : new Array,
  rowCount    : 0,
  localSize   : 0,
  localAvailableDiskSpace : 0,
  getCellText : function(row, column) {                            // text for the files
    if (row == -1)
      return " ";
    switch(column.id) {
      case "localname":
        return this.displayData[row].leafName;
      case "localsize":
        return this.displayData[row].fileSize;
      case "localdate":
        return this.displayData[row].date;
      case "localtype":
        return this.displayData[row].extension;
      case "localattr":
        return this.displayData[row].attr;
      default:
        return " "; // shouldn't get here
    }
  },
  getExtension : function(leafName) {
    if (leafName.lastIndexOf(".") != -1)
      return leafName.substring(leafName.lastIndexOf(".") + 1, leafName.length).toLowerCase();
    else
      return "";
  },
  convertPermissions : function(hidden, permissions) {
    if (slash == "\\") {           // msdos
      var returnString = "";
      if (permissions == 438)      // Normal file  (666 in octal)
        returnString = strbundle.getString("normalFile");
      else if (permissions == 511) // Executable file (777 in octal)
        returnString = strbundle.getString("executableFile");
      else if (permissions == 292) // Read-only (444 in octal)
        returnString = strbundle.getString("readOnlyFile");
      else if (permissions == 365) // Read-only and executable (555 in octal)
        returnString = strbundle.getString("readOnlyExecutableFile");
      else
        returnString = " ";
      if (hidden)
        returnString += strbundle.getString("hiddenFile");
      return returnString;
    } else {
      var binary = permissions.toString(2);
      var permissionsString = "";
      for (var x = 0; x < 9; x += 3) {
        if (binary.charAt(0 + x) == "1")
          permissionsString += "r";
        else
          permissionsString += "-";
        if (binary.charAt(1 + x) == "1")
          permissionsString += "w";
        else
          permissionsString += "-";
        if (binary.charAt(2 + x) == "1")
          permissionsString += "x";
        else
          permissionsString += "-";
      }
      return permissionsString;
    }
  },
  getImageSrc  : function(row,col)  {                              // icons for the files
    if (row == -1)
      return "";
    if (col.id == "localname" && this.displayData[row].icon)
      return this.displayData[row].icon;
    return "";
  },
  cycleHeader : function(col) {
    var sortDirection = col.element.getAttribute("sortDirection") == "ascending" || col.element.getAttribute("sortDirection") == "natural"
              ? "descending" : "ascending";
    document.getElementById('localname').setAttribute("sortDirection", "natural");
    document.getElementById('localsize').setAttribute("sortDirection", "natural");
    document.getElementById('localdate').setAttribute("sortDirection", "natural");
    document.getElementById('localtype').setAttribute("sortDirection", "natural");
    document.getElementById('localattr').setAttribute("sortDirection", "natural");
    col.element.setAttribute("sortDirection", sortDirection);
    this.sort();
  },
  getCellProperties : function(row, col, props)   {
    if (row == -1)
      return;
    if (col.id == "localname" && this.data[row].isDirectory())
      props.AppendElement(gAtomService.getAtom("isFolder"));
  },
  getParentIndex      : function(row)               { return -1; },
  getColumnProperties : function(colid, col, props) {},
  getLevel            : function(row)               { return 0; },
  getRowProperties    : function(row, props)        {},
  isContainer         : function(row)               { return false; },
  isSeparator         : function(row)               { return false; },
  isSorted            : function(row)               { return false; },
  setTree             : function(treebox)           { this.treebox = treebox; },

  // ************************************************* mouseEvent *****************************************************

  dblClick : function(event) {
    if (event.button != 0 || event.originalTarget.localName != "treechildren" || this.selection.count == 0)
      return;

    if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
      this.selection.currentIndex = this.rowCount - 1;

    if (!localFile.verifyExists(this.data[this.selection.currentIndex]))
      return;

    if (this.data[this.selection.currentIndex].isDirectory())              // if it's a directory
      localDirTree.changeDir(this.data[this.selection.currentIndex].path); // navigate to it
    else
      transfer(false);                                                     // else upload the file
  },
  click : function(event) {
    if (event.button == 1 && !document.getElementById('localPasteContext').disabled)    // middle-click paste
      this.paste();
    else {                                                                 // build the open with menu for the selected file
      if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
      this.selection.currentIndex = this.rowCount - 1;

      for (var x = document.getElementById('openWithMenu').childNodes.length - 1; x >= 0; --x)    // clear out the menu
        document.getElementById('openWithMenu').removeChild(document.getElementById('openWithMenu').childNodes.item(x));

      var extension = this.getExtension(this.data[this.selection.currentIndex].leafName);
      var item;

      var found = false;
      for (var x = 0; x < programs.length; ++x) {
        if (programs[x].extension.toLowerCase() == extension.toLowerCase()) {
          for (var y = 0; y < programs[x].programs.length; ++y) {
            found = true;
            item = document.createElement("menuitem");
            item.setAttribute("class", "menuitem-iconic");
            var program = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
            program.initWithPath(programs[x].programs[y].executable);
            var fileURI = ios.newFileURI(program);
            item.setAttribute("image", "moz-icon://" + fileURI.spec + "?size=16");
            item.setAttribute("label", programs[x].programs[y].name);
            item.setAttribute("oncommand", "launchProgram(" + x + ", " + y + ", " + this.selection.currentIndex + ")");
            document.getElementById('openWithMenu').appendChild(item);
          }
          break;
        }
      }
      for (var x = 0; x < programs.length; ++x) {
        if (programs[x].extension == "*.*") {
          for (var y = 0; y < programs[x].programs.length; ++y) {
            found = true;
            item = document.createElement("menuitem");
            item.setAttribute("class", "menuitem-iconic");
            var program = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
            program.initWithPath(programs[x].programs[y].executable);
            var fileURI = ios.newFileURI(program);
            item.setAttribute("image", "moz-icon://" + fileURI.spec + "?size=16");
            item.setAttribute("label", programs[x].programs[y].name);
            item.setAttribute("oncommand", "launchProgram(" + x + ", " + y + ", " + this.selection.currentIndex + ")");
            document.getElementById('openWithMenu').appendChild(item);
          }
          break;
        }
      }

      if (found) {
        item = document.createElement("menuseparator");
        document.getElementById('openWithMenu').appendChild(item);
      }

      item = document.createElement("menuitem");
      item.setAttribute("label", "Choose Program...");
      item.setAttribute("oncommand", "chooseProgram()");
      document.getElementById('openWithMenu').appendChild(item);
    }
  },
  mouseOver : function(event) {                                            // display local folder info
    if (this.rowCount)
      document.getElementById('statustxt').label =
        strbundle.getString("localListing") + " " + this.rowCount + " " + strbundle.getString("objects") + " "
        + commas(this.localSize) + ", " + strbundle.getString("diskSpace") + " " + this.localAvailableDiskSpace;
    else
      document.getElementById('statustxt').label = strbundle.getString("localListingNoObjects");
  },

  // ************************************************* keyEvent *****************************************************

  keyPress : function(event) {
    if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
      this.selection.currentIndex = this.rowCount - 1;

    if (event.keyCode == 13 && this.selection.count != 0) {                                     // enter
      if (!localFile.verifyExists(this.data[this.selection.currentIndex]))
        return;
      if (this.selection.count == 1 && this.data[this.selection.currentIndex].isDirectory())    // if it's a directory
        localDirTree.changeDir(this.data[this.selection.currentIndex].path);                    // navigate to it
      else
        transfer(false);                                                                        // else upload a file
    } else if (event.ctrlKey && (event.which == 65 || event.which == 97)) {
      event.preventDefault();                                                                   // ctrl-a: select all
      this.selection.selectAll();
    } else if (event.ctrlKey && event.which == 32 && this.selection.count != 0)                 // ctrl-space, select or deselect
      this.selection.toggleSelect(this.selection.currentIndex);
    else if (event.keyCode == 8) {                                                              // backspace
      event.preventDefault();
      localDirTree.cdup();
    } else if (event.keyCode == 116) {                                                          // F5
      event.preventDefault();
      this.refresh();
    } else if (event.keyCode == 113 && this.selection.count != 0)                               // F2
      this.rename();
    else if (event.charCode == 109 && event.ctrlKey) {                                          // ctrl-m
      event.preventDefault();
      this.createDirectory();
    } else if (event.keyCode == 46 && this.selection.count != 0)                                // del
      this.remove();
    else if (event.keyCode == 93) {                                                             // display context menu
      var x = {};    var y = {};    var width = {};    var height = {};
      this.treebox.getCoordsForCellItem(this.selection.currentIndex, this.treebox.columns["localname"], "text", x, y, width, height);
      document.getElementById('localmenu').showPopup(
        gLocalTreeChildren, gLocalTreeChildren.boxObject.x + 75, gLocalTreeChildren.boxObject.y + y.value + 5, "context");
    } else if (event.charCode == 112 && event.ctrlKey && this.selection.count != 0) {           // ctrl-p
      event.preventDefault();
      this.showProperties(false);
    } else if (event.charCode == 120 && event.ctrlKey && this.selection.count != 0) {           // ctrl-x
      event.preventDefault();
      this.cut();
    } else if (event.charCode == 99 && event.ctrlKey && this.selection.count != 0) {            // ctrl-c
      event.preventDefault();
      this.copy();
    } else if (event.charCode == 118 && event.ctrlKey) {                                        // ctrl-v
      event.preventDefault();
      this.paste();
    } else if (event.charCode == 111 && event.ctrlKey) {                                        // ctrl-o
      event.preventDefault();
      this.openWith();
    }
  },

  // ****************************************************** file functions ***************************************************

  constructPath : function(parent, leafName) {
    return parent + (parent.charAt(parent.length - 1) != slash ? slash : '') + leafName;
  },
  launch : function() {
    if (this.rowCount > 0 && this.selection.count > 0) {
      if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
        this.selection.currentIndex = this.rowCount - 1;
      if (!localFile.verifyExists(this.data[this.selection.currentIndex]))
        return;
      localFile.launch(this.data[this.selection.currentIndex]);
    }
  },
  createDirectory : function() {
    if (localFile.createDirectory())
      localTree.refresh();
  },
  remove : function() {
    if (this.selection.count == 0)
      return;

    var prompt = true;
    for (var x = 0; x < this.rowCount; ++x)
      if (this.selection.isSelected(x)) {
        if (!localFile.verifyExists(this.data[x]))
          continue;
        if (!localFile.remove(this.data[x], prompt, this.selection.count))
          break;
        prompt = false;
      }
    
    localTree.refresh();
  },
  rename : function() {
    if (this.rowCount > 0 && this.selection.count > 0) {
      if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
        this.selection.currentIndex = this.rowCount - 1;
      if (!localFile.verifyExists(this.data[this.selection.currentIndex]))
        return;
      if (localFile.rename(this.data[this.selection.currentIndex]))
        localTree.refresh();
    }
  },
  showProperties : function(recursive) {
    if (this.rowCount > 0 && this.selection.count > 0) {
      if (this.selection.currentIndex < 0 || this.selection.currentIndex >= this.rowCount)
        this.selection.currentIndex = this.rowCount - 1;
      if (this.selection.count > 1) {                                              // multiple files
        var recursiveFolderData = { type: "local", nFolders: 0, nFiles: 0, nSize: 0 };
        for (var x = 0; x < this.rowCount; ++x)
          if (this.selection.isSelected(x)) {
            if (!localFile.verifyExists(this.data[x]))
              continue;
            if (this.data[x].isDirectory()) {
              ++recursiveFolderData.nFolders;
              if (recursive)
                this.getRecursiveFolderData(this.data[x], recursiveFolderData);
            } else
              ++recursiveFolderData.nFiles;
            recursiveFolderData.nSize += this.data[x].fileSize;
          }

        var params = { multipleFiles       : true,
                       recursiveFolderData : recursiveFolderData };
        
        dialogOpen = true;
        window.openDialog("chrome://fireftp/content/properties.xul","properties",
          "width=600,height=360,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);
        dialogOpen = false;
        return;
      }
      if (!localFile.verifyExists(this.data[this.selection.currentIndex]))
        return;
      if (localFile.showProperties(this.data[this.selection.currentIndex], recursive))
        localTree.refresh();
    }
  },
  getRecursiveFolderData : function(dir, recursiveFolderData) {
    try {
      var entries = dir.directoryEntries;
      while (entries.hasMoreElements()) {
        var file = entries.getNext().QueryInterface(Components.interfaces.nsIFile);
        if (file.exists() && (!file.isHidden() || hiddenMode)) {
          if (file.isDirectory()) {
            ++recursiveFolderData.nFolders;
            this.getRecursiveFolderData(file, recursiveFolderData);
          } else
            ++recursiveFolderData.nFiles;
          recursiveFolderData.nSize += file.fileSize;
        }
      }
    } catch (ex) {
      return;                                                                      // skip this directory
    }
  },

  // ****************************************************** refresh ***************************************************

  refresh : function(skipLocalTree) {
    if (localDirTree.data[localDirTree.selection.currentIndex].open) {             // if localDirTree is open
      localDirTree.toggleOpenState(localDirTree.selection.currentIndex);           // close it up
      localDirTree.data[localDirTree.selection.currentIndex].children = null;      // reset its children
      localDirTree.toggleOpenState(localDirTree.selection.currentIndex);           // and open it up again
    } else
      localDirTree.data[localDirTree.selection.currentIndex].empty = false;        // not empty anymore
    if (!skipLocalTree)
      setTimeout("localTree.updateView()", 1000);                                  // update localTree, after a little bit
  },

  // ****************************************************** updateView ***************************************************

  updateView : function(column, direction) {
    var localTreeItems = new Array;

    try {
      this.localSize = 0;
      var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
      dir.initWithPath(gLocalPath.value);
      this.localAvailableDiskSpace = parseSize(dir.diskSpaceAvailable);            // get local disk size
      var entries = dir.directoryEntries;
      while (entries.hasMoreElements()) {
        var file = entries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
        if (file.exists() && (!file.isHidden() || hiddenMode)) {
          localTreeItems.push(file);
          this.localSize += file.fileSize;
        }
      }
    } catch (ex) {
      error(strbundle.getString("noPermission"));
      debug(ex,31);
      return;
    }
    this.localSize = parseSize(this.localSize);                                    // get directory size

    this.data = localTreeItems;                                                    // update localTree
    this.sort();

    localDirTree.reselectCurrentDirectory();                                       // select directory in localDirTree
    if (this.data.length)
      this.selection.select(0);                                                    // select first element in localTree
    this.mouseOver(null);
  },
  sort : function() {
    if (document.getElementById('localname').getAttribute("sortDirection") &&
        document.getElementById('localname').getAttribute("sortDirection") != "natural") {
      this.data.sort(compareLocalName);
      if (document.getElementById('localname').getAttribute("sortDirection") == "ascending")
        this.data.reverse();
    }
    if (document.getElementById('localsize').getAttribute("sortDirection") && 
        document.getElementById('localsize').getAttribute("sortDirection") != "natural") {
      this.data.sort(compareLocalSize);
      if (document.getElementById('localsize').getAttribute("sortDirection") == "ascending")
        this.data.reverse();
    }
    if (document.getElementById('localdate').getAttribute("sortDirection") &&
        document.getElementById('localdate').getAttribute("sortDirection") != "natural") {
      this.data.sort(compareLocalDate);
      if (document.getElementById('localdate').getAttribute("sortDirection") == "ascending")
        this.data.reverse();
    }
    if (document.getElementById('localtype').getAttribute("sortDirection") &&
        document.getElementById('localtype').getAttribute("sortDirection") != "natural") {
      this.data.sort(compareLocalType);
      if (document.getElementById('localtype').getAttribute("sortDirection") == "ascending")
        this.data.reverse();
    }
    if (document.getElementById('localattr').getAttribute("sortDirection") &&
        document.getElementById('localattr').getAttribute("sortDirection") != "natural") {
      this.data.sort(compareLocalAttr);
      if (document.getElementById('localattr').getAttribute("sortDirection") == "ascending")
        this.data.reverse();
    }

    this.displayData = new Array;
    for (var row = 0; row < this.data.length; ++row) {
      var fName = this.data[row].leafName;
      var fSize = this.getFormattedFileSize(row);
      var fDate = this.getFormattedDate(row);
      var fExt = this.getExtension(this.data[row].leafName);
      var fAttr = this.data[row].permissions ? this.convertPermissions(this.data[row].isHidden(), this.data[row].permissions) : "";
      var fIcon = this.getFileIcon(row);
      var formattedData = { leafName : fName, fileSize: fSize, date: fDate, extension: fExt, attr: fAttr, icon: fIcon };
      this.displayData.push(formattedData);
    }

    this.treebox.rowCountChanged(0, -this.rowCount);
    this.rowCount = this.data.length;
    this.treebox.rowCountChanged(0, this.rowCount);
  },
  getFormattedFileSize : function(row) {
    if (this.data[row].isDirectory())
      return "";
    if (this.data[row].fileSize == 0)
      return "0" + (bytesMode ? "  " : " KB  ");
    if (bytesMode)
      return this.data[row].fileSize + "  ";
    else
      return commas(Math.floor(this.data[row].fileSize / 1024) + 1) + " KB  ";
  },
  getFormattedDate : function(row) {
    var date = new Date(this.data[row].lastModifiedTime);
    if ((new Date()).getYear() < date.getYear())                                   // if not current year, display old year
      return months[date.getMonth()] + ' ' + date.getDate() + ' ' + date.getYear();
    else {
      var time = date.toLocaleTimeString();                                        // else display time
      return months[date.getMonth()] + ' ' + date.getDate() + ' ' + time.substring(0, time.lastIndexOf(':'));
    }
  },
  getFileIcon : function(row) {
    if (this.data[row].isDirectory())
      return "";
    var fileURI = ios.newFileURI(this.data[row]);
    return "moz-icon://" + fileURI.spec + "?size=16";                              // thanks to alex sirota!
  },

  // ************************************************* cut, copy, paste *****************************************************

  isCut      : false,
  pasteFiles : new Array,
  oldParent  : "",
  cut  : function() {
    this.copy(true);
  },
  copy : function(isCut) {
    if (this.selection.count == 0)
      return;

    this.isCut = isCut;
    this.pasteFiles = new Array;
    this.oldParent = gLocalPath.value;
    for (var x = 0; x < this.rowCount; ++x)                                        // put files to be cut/copied in an array to be used when pasting
      if (this.selection.isSelected(x)) {
        if (localFile.verifyExists(this.data[x]))
          this.pasteFiles.push(this.data[x]);
      }

    document.getElementById('localPasteContext').setAttribute("disabled", false);  // enable pasting
  },
  paste : function() {
    if (this.pasteFiles.count == 0)
      return;

    var newParent = gLocalPath.value;
    if (!localFile.verifyExists(this.pasteFiles[0]))
      return;
    if (newParent.indexOf(this.pasteFiles[0].path) != -1)                          // can't copy into a subdirectory of itself
      return;
    
    var prompt = true;
    var skipAll = false;
    var overwrite = false;

    try {
      var newDir = localDirTree.getFile(localDirTree.indexOfPath(newParent));
      for (var x = 0; x < this.pasteFiles.length; ++x) {
        if (!localFile.verifyExists(this.pasteFiles[x]))
          continue;
        var newFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
        newFile.initWithPath(this.constructPath(newDir.path, this.pasteFiles[x].leafName));

        if (newFile.exists() && skipAll)
          continue;
        if (newFile.exists() && prompt) {                                          // ask nicely
          var params = { response         : 0,
                         fileName         : this.pasteFiles[x].leafName,
                         resume           : true,
                         replaceResume    : true,
                         timerEnable      : false };

          dialogOpen = true;
          window.openDialog("chrome://fireftp/content/confirmFile.xul","confirmFile",
            "width=425,height=90,chrome,modal=yes,dialog=yes,resizable=yes,centerscreen", params);
          dialogOpen = false;
          
          if (params.response == 1)
            overwrite = true;
          if (params.response == 2)
            prompt = false;
          else if (params.response == 3)
            continue;
          else if (params.response == 4 || params.response == 0)
            return;
          else if (params.response == 5) {
            skipAll = true;
            continue;
          }
        }

        if (newFile.exists() && (!prompt || overwrite)) {
          newFile.remove(true);
          overwrite = false;
        }

        if (this.isCut)
          this.pasteFiles[x].moveTo(newDir, null);                                 // cut
        else
          this.pasteFiles[x].copyTo(newDir, null);                                 // or copy
      }
    } catch (ex) {
      debug(ex,36);
      error(strbundle.getString("pasteError"));
    }
    
    if (this.isCut) {                                                              // reset variables if it was a cut
      localDirTree.selection.currentIndex = localDirTree.indexOfPath(this.oldParent);
      this.refresh(true);
      gLocalPath.value = newParent;
      localDirTree.selection.currentIndex = localDirTree.indexOfPath(newParent);
      this.pasteFiles = new Array;
      this.isCut = false;
      document.getElementById('localPasteContext').setAttribute("disabled", true);
    }

    this.refresh();
  },
  canDrop : function (aIndex, aOrientation) { return false; },
  drop : function (aIndex, aOrientation) { }
};
